//
//  RedirectResolver.h
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//
#import <Foundation/Foundation.h>
#import "TransactionLifecycleAdapter.h"
#import "TransactionLifecycleAdapter.h"
#import "TransactionSuccess.h"
#import "TransactionError.h"
#import "InputResolver.h"
#import "BusinessError.h"
#import "AddPaymentMethodLifecycleAdapter.h"
#import "SharedLifecycleDelegate.h"

extern const int STARTED_TRANSACTION;
extern const int TRANSACTION_SUCCESS;
extern const int TRANSACTION_FAILURE;
extern const int TIMEOUT;
extern const int UNKNOWN;
extern const int THREE_DS;
extern const int STARTED_TRANSACTION_3DS;
extern const int IGNORE;
extern const int ADD_PAYMENT_METHOD_STARTED_TRANSACTION;
extern const int ADD_PAYMENT_METHOD_THREE_DS;
extern const int ADD_PAYMENT_METHOD_STARTED_TRANSACTION_3DS;
extern const int ADD_PAYMENT_METHOD_SUCCESS;
extern const int ADD_PAYMENT_METHOD_FAILURE;


@interface RedirectResolver : NSObject


@property(weak, nonatomic) id<SharedLifecycleDelegate> delegate;
@property bool transactionInProgress;
-(int) resolve: (NSString *) request;
-(void) notifyDelegate: (int) resolvedCode
               request: (NSString *) request;
-(id) init: (TransactionLifecycleAdapter *) adapter
   timeout: (long) timeout;

-(id) initAddPayment: (AddPaymentMethodLifecycleAdapter *) adapter
   timeout: (long) timeout;

-(void) stopTimeoutTracking;
-(void) startTimeoutTracking;
-(void) logTransactionInfo:(NSString *)loggingInfo;
@end
