//
//  PayCvvViewController.m
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import "PayCvvViewController.h"
#import "PayCvvOrderDetails.h"
#import "MerchantProvider.h"
#import "Merchant.h"

@interface PayCvvViewController ()
@property (weak, nonatomic) IBOutlet WebtehWebView *webtehWebView;
@property (weak, nonatomic) IBOutlet UIActivityIndicatorView *progressBar;

@end

@implementation PayCvvViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    NSArray *merchants = [MerchantProvider getAllMerchants];
    
    Merchant *merchant = [merchants objectAtIndex:0];
    
    // Do any additional setup after loading the view.
    PgwApi *api = [[PgwApi alloc] init:[merchant authenticationToken] isDebug:true];
    NSTimeInterval  today = [[NSDate date] timeIntervalSince1970];
    NSString *orderNumber = [NSString stringWithFormat:@"%.0f", today*1000];
    
    TransactionLifecycleAdapter * adapter = [[TransactionLifecycleAdapter alloc] init:self api:api merchantKey:[merchant merchantKey] orderNumber:orderNumber mode:SHOW_ORDER_RESPONSE];
    [_webtehWebView initialize:adapter isDebug:true timeout:10000];
    
    Customer *customer = [[Customer alloc] init:@"John Smith"
                                          email:@"test@test.com"
                                        address:@"Address"
                                    phoneNumber:@"+1-202-555-0138"
                                           city:@"Sarajevo"
                                         userId:@"userIdRandom"
                          ];
    
    OrderDetails *orderDetails = [[OrderDetails alloc]
                                  init:@"1250"
                                  orderNumber:orderNumber
                                  currency:@"EUR"
                                  orderInfo:@"orderInfo"
                                  signature:@"009"
                                  client:@"cvv_ios"
                                  ];
    
    PayCvvOrderDetails *payCvvOrderDetails = [[PayCvvOrderDetails alloc] init:orderDetails pmAlias:@"6940JLtKcYp1OYy7cmPYTWbnvxHt7vknF-9PIESG"];
    
    PayCvvModel *model = [[PayCvvModel alloc] init:merchant payCvvOrderDetails:payCvvOrderDetails customer:customer];
    
    [_webtehWebView payCvv:model];
}

-(void) showProgress{
    NSLog(@"showProgress");
    [self.progressBar startAnimating];
}
-(void) hideProgress{
    NSLog(@"hideProgress");
    [self.progressBar stopAnimating];
}

-(void) handleTransactionError: (ApiError *) error{
    NSLog(@"handleTransactionError %@", error);
}

-(void) transactionSuccess: (TransactionSuccess *) success{
    NSLog(@"transactionSuccess %@", success);
}
    
    -(void) logTransactionInfo:(NSString *)loggingInfo {
        NSLog(@"log info: %@", loggingInfo);
    }

@end

