//
//  PayCvvModel.m
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "PayCvvModel.h"
#import "PayModel.h"
#import "InputResolver.h"

@implementation PayCvvModel

-(id) init:(NSString *)merchantId pmAlias:(NSString *)pmAlias client:(NSString *)client orderInfo:(NSString *)orderInfo orderNumber:(NSString *)orderNumber sign:(NSString *)sign amount:(NSString *)amount currency:(NSString *)currency clientSecret:(NSString *)clientSecret authToken:(NSString *)authToken{
    return [self init:merchantId pmAlias:pmAlias client:client orderInfo:orderInfo orderNumber:orderNumber sign:sign amount:amount currency:currency clientSecret:clientSecret authToken:authToken customer:nil];
}

-(id) init:(NSString *)merchantId pmAlias:(NSString *)pmAlias client:(NSString *)client orderInfo:(NSString *)orderInfo orderNumber:(NSString *)orderNumber sign:(NSString *)sign amount:(NSString *)amount currency:(NSString *)currency clientSecret:(NSString *)clientSecret authToken:(NSString *)authToken customer:(Customer *)customer {
    _merchantId = merchantId;
    _client = client;
    _orderInfo = orderInfo;
    _orderNumber = orderNumber;
    _sign = sign;
    _amount = amount;
    _currency = currency;
    _clientSecret = clientSecret;
    _authToken = authToken;
    _pmAlias = pmAlias;
    _digest = [PayModel sha1: [NSString stringWithFormat:@"%@%@%@%@%@%@%@%@",
                               _merchantId,
                               _pmAlias,
                               _authToken,
                               _orderNumber,
                               _sign,
                               _amount,
                               _currency,
                               _clientSecret
                               ]];
    
    _customer = customer;
    
    return [self init];
}

- (id)init:(Merchant *)merchant payCvvOrderDetails:(PayCvvOrderDetails *)payCvvOrderDetails customer:(Customer *)customer {
    
    OrderDetails *orderDetails =[ payCvvOrderDetails orderDetails];
    
    _merchantId = [merchant merchantId];
    _client = [orderDetails client];
    _orderInfo = [orderDetails orderInfo];
    _orderNumber = [orderDetails orderNumber];
    _sign = [orderDetails signature];
    _amount = [orderDetails amount];
    _currency = [orderDetails currency];
    _clientSecret = [merchant clientSecret];
    _authToken = [merchant authenticationToken];
    _pmAlias = [payCvvOrderDetails pmAlias];
    _digest = [PayModel sha1: [NSString stringWithFormat:@"%@%@%@%@%@%@%@%@",
                               _merchantId,
                               _pmAlias,
                               _authToken,
                               _orderNumber,
                               _sign,
                               _amount,
                               _currency,
                               _clientSecret
                               ]];
    
    _customer = customer;
    return [self init];
}

-(NSString *) toInput{
    NSMutableDictionary *data = [[NSMutableDictionary alloc] init];
    
    [data setValue:_client forKey:@"client"];
    [data setValue:_merchantId forKey:@"merchant_id"];
    [data setValue:_orderInfo forKey:@"order_info"];
    [data setValue:_orderNumber forKey:@"order_number"];
    [data setValue:_sign forKey:@"sign"];
    [data setValue:_amount forKey:@"amount"];
    [data setValue:_currency forKey:@"currency"];
    [data setValue:_clientSecret forKey:@"client_secret"];
    [data setValue:_authToken forKey:@"auth_token"];
    [data setValue:_digest forKey:@"digest"];
    [data setValue:_pmAlias forKey:@"pm_alias"];
    
    return [InputResolver encode:data];
}

@end
