//
//  StartedTransactionResolverRunnable.m
//  WebtehPaymentLib
//
//  Created by Jasmin Suljic on 04/10/2018.
//

#import <Foundation/Foundation.h>
#import "StartedTransactionResolverRunnable.h"
#import "RedirectResolver.h"

@interface StartedTransactionResolverRunnable()
    @property(nonatomic, weak) id<SharedLifecycleDelegate> delegate;
@end

@implementation StartedTransactionResolverRunnable

- (id)init:(id<SharedLifecycleDelegate>) delegate {
    _delegate = delegate;
    return [self init];
}

- (void)run:(int)resolvedCode request:(NSString *)request redirectResolver:(RedirectResolver *)redirectResolver inputParam:(NSString *)inputParam {
    redirectResolver.transactionInProgress = true;
    [redirectResolver startTimeoutTracking];
    
    [_delegate showProgress];
    
    if (resolvedCode == STARTED_TRANSACTION_3DS) {
        if([_delegate respondsToSelector:@selector(threeDsSubmitted)]) {
            [redirectResolver logTransactionInfo:[NSString stringWithFormat:@"_transactionLifecycleAdapter.delegate#threeDsSubmitted"]];
            [_delegate threeDsSubmitted];
        }
    }
}

@end
